local ClassicPowerText = CreateFrame("frame")

local color, mana, percent = "FFFFFF", mana, percent --Define some locals
--local options, opttitle, optslider, optfonttitle, optlock
local pf = CreateFrame("Frame", nil, UIParent)
local pt = pf:CreateTexture(nil, "BACKGROUND")
local pp = pf:CreateFontString(nil, "ARTWORK", "GameFontNormalHuge")
pf:SetFrameStrata("MEDIUM")

function ClassicPowerText_OnLoad(self)
    self:RegisterEvent("UNIT_POWER")
    self:RegisterEvent("ADDON_LOADED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
    ClassicPowerText:SetScript("OnEvent", ClassicPowerText_OnEvent)
	ClassicPowerText:SetScript("OnUpdate", ClassicPowerText_OnUpdate)
end

function ClassicPowerText_UpdatePower()
	local newValue = CPT_DB.color
	if (percent < 4) then pp:Hide() else pp:Show() end
    if newValue == "0" then --default
		if (percent >= 80) then --green
			color = "00CD00"
		elseif (percent < 80 and percent >= 40) then --yellow
			color = "FFFF00"
		elseif (percent < 40 and percent >= 20) then -- orange
			color = "FF6600"
		elseif (percent < 20 and percent >= 4) then --red
			color = "FF0033"
		end
		pp:SetText("|cFF"..color..UnitPower("player").."|r")
	elseif newValue == "1" then -- class colors
		local _, class = UnitClass("player")
		local r, g, b = RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b
		pp:SetTextColor(r, g, b, CPT_DB.alphain)
		pp:SetText(UnitPower("player"))
	elseif newValue == "2" then -- power colors
		local r, g, b
		local _, class = UnitClass("player")
		if class == "ROGUE" then
			r, g, b = PowerBarColor["ENERGY"].r, PowerBarColor["ENERGY"].g, PowerBarColor["ENERGY"].b
		elseif class == "WARRIOR" then
			r, g, b = PowerBarColor["RAGE"].r, PowerBarColor["RAGE"].g, PowerBarColor["RAGE"].b
		elseif class == "HUNTER" then
			r, g, b = PowerBarColor["FOCUS"].r, PowerBarColor["FOCUS"].g, PowerBarColor["FOCUS"].b
		elseif class == "DEATHKNIGHT" then
			r, g, b = PowerBarColor["RUNIC_POWER"].r, PowerBarColor["RUNIC_POWER"].g, PowerBarColor["RUNIC_POWER"].b
		elseif class == "DRUID" then
			local stance = GetShapeshiftForm()
			if stance == 3 then -- cat
				r, g, b = PowerBarColor["ENERGY"].r, PowerBarColor["ENERGY"].g, PowerBarColor["ENERGY"].b
			elseif stance == 1 then -- bear
				r, g, b = PowerBarColor["RAGE"].r, PowerBarColor["RAGE"].g, PowerBarColor["RAGE"].b
			end
		else
			r, g, b = PowerBarColor["MANA"].r, PowerBarColor["MANA"].g, PowerBarColor["MANA"].b
		end
		pp:SetTextColor(r, g, b, CPT_DB.alphain)
		pp:SetText(UnitPower("player"))
	elseif newValue == "3" then -- custom colors
		local r = CPT_DB.color_picker.r
		local g = CPT_DB.color_picker.g
		local b = CPT_DB.color_picker.b
		local o = CPT_DB.color_picker.opacity
		pp:SetTextColor(r, g, b, o)
		pp:SetText(UnitPower("player"))
	end
end

function ClassicPowerText_OnEvent(self, event, name, ...)
    if (event == "UNIT_POWER") then
        mana = (UnitPowerMax("player") / UnitPower("player")) --Used to find the percent of Runic Power
        percent = (100 / mana)
        ClassicPowerText_UpdatePower();
	elseif (event == "PLAYER_REGEN_DISABLED") then
        pf:SetAlpha(CPT_DB.alphain)
    elseif (event == "PLAYER_REGEN_ENABLED") then
        pf:SetAlpha(CPT_DB.alphaout)
    elseif (event == "PLAYER_ENTERING_WORLD") then
        pf:SetAlpha(CPT_DB.alphaout)
    elseif (event == "ADDON_LOADED" and name == "ClassicPowerText") then
        
        pf:SetFrameStrata("BACKGROUND")
        pf:SetFrameLevel(0)
        pf:SetWidth(50)
        pf:SetHeight(50)
        pf:Show();
        
        pp:SetPoint("CENTER", pf)
		pf:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", CPT_DB.x, CPT_DB.y)
        pp:SetText("|cffffffffCPT|r")
        pp:Show();
    end
end

local time = 0
function ClassicPowerText_OnUpdate(self, elapsed)
	time = time - elapsed
	
	if time < 0 then
		pp:SetFont(STANDARD_TEXT_FONT, CPT_DB.size)
		self:SetScript("OnUpdate", nil)
	end
end

function ClassicPowerText_Size(newValue)
	pp:SetFont(STANDARD_TEXT_FONT, tonumber(newValue))
end

function ClassicPowerText_AlphaOut(newValue)
	local newValue = tonumber(newValue)
    pf:SetAlpha(newValue)
end

function ClassicPowerText_Lock(newValue)
    if newValue == "1" then
		print("WORKING")
        pt:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
        pt:SetAllPoints(pf)
        pf:SetFrameLevel(5)
        pf:SetFrameStrata("DIALOG")
        pf:SetMovable(true)
        pf:EnableMouse(true)
        pf:RegisterForDrag("LeftButton")
        pf:SetClampedToScreen(true)
        pf:SetScript("OnDragStart", pf.StartMoving)
        pf:SetScript("OnDragStop", function() pf:StopMovingOrSizing()
        CPT_DB.x, CPT_DB.y = pf:GetLeft(), pf:GetBottom() end)
    elseif newValue == "0" then
        pt:SetTexture(nil)
        pf:SetFrameLevel(0)
        pf:SetFrameStrata("MEDIUM")
        pf:SetMovable(false)
        pf:EnableMouse(false)
    end
end

--[[function ClassicPowerText_BlizzOptions()
    options = CreateFrame("frame", nil, UIParent);
    options.name = "ClassicPowerText";
    options:SetWidth(300);
    options:SetHeight(200);
    
    opttitle = options:CreateFontString(nil, "ARTWORK", "GameFontNormalHuge")
    opttitle:SetText("ClassicPowerText")
    opttitle:SetPoint('TOP', options, 'TOP', -95, -10)
    --Scale slider
    optslider = CreateFrame("Slider", "CPT_FontSlider", options, "OptionsSliderTemplate")
    optslider:SetMinMaxValues(15, 40)
    optslider:SetValueStep(1)
    optslider:SetWidth(160)
    getglobal('CPT_FontSliderLow'):SetText("Small")
    getglobal('CPT_FontSliderHigh'):SetText("Large")
    --Scale value string
    optfonttitle = options:CreateFontString(nil, "ARTWORK", "GameFontNormal")
    optfonttitle:SetText(CPT_DB.size)
    optfonttitle:SetPoint("BOTTOM", optslider, "BOTTOM", 0, -10)
    optslider:SetScript('OnShow', function(self) self:SetValue(CPT_DB.size) end)
    optslider:SetScript('OnValueChanged', ClassicPowerText_Size)
    optslider:SetPoint('CENTER', options, 'CENTER', 0, 20)
    
    --Checkbox (Lock/Unlock)
    optlock = CreateFrame("CheckButton", "CPT_Lock", options, "OptionsCheckButtonTemplate");
    _G[optlock:GetName().."Text"]:SetText("Unlock Frame")
    optlock:SetScript('OnShow', function(self) self:SetChecked(CPT_DB.unlocked) end)
    optlock:SetScript('OnClick', ClassicPowerText_UnLock)
    optlock:SetPoint('BOTTOM', optslider, 'BOTTOM', 0, -40)
    
    InterfaceOptions_AddCategory(options);
end]]

SlashCmdList["CLASSICPOWERTEXT"] = function(msg)
    ClassicPowerText_SlashHandler(string.lower(msg));
end

SLASH_CLASSICPOWERTEXT1 = "/classicpowertext"
SLASH_CLASSICPOWERTEXT2 = "/cpt"
SLASH_CLASSICPOWERTEXT3 = "/cptext"

function ClassicPowerText_SlashHandler(msg)
	local frame = LibStub("Portfolio").GetOptionsFrame("ClassicPowerText")
    InterfaceOptionsFrame_OpenToCategory(frame)
end

ClassicPowerText_OnLoad(ClassicPowerText)